#ifndef CHANNEL_H
#define CHANNEL_H

#include <vhttpd/buffer.h>
#include <vhttpd/socket.h>

/* generic channel*/
typedef struct channel_t channel_t;

#define CHANNEL_TYPE_UNKNOWN    (0)
#define CHANNEL_TYPE_PLAIN      (1)

#define CHANNEL_T(p) ((channel_t *)(p))

#define C_SO_DEFAULT_SERVER     (C_SO_FATAL|C_SO_NOBLK|C_SO_SERVER)
#define C_SO_DEFAULT_CLIENT     (0)

channel_t *create_channel_from_socket (int socket_fd, const char *remote_addr, int flags);
channel_t *create_inet_channel (const char *addr, const char *service, int flags);
channel_t *create_unix_channel (const char *path, int flags);
void channel_unix_set_ownership (channel_t *c, const char *user, const char *group);
int channel_get_type (const channel_t *);
int channel_get_fd (const channel_t *);
const char *channel_get_remoteaddr (const channel_t *);
channel_t *channel_accept (channel_t *);
int channel_send (channel_t *, const char *, size_t);
int channel_sendfile (channel_t *, int, size_t);
int channel_receive (channel_t *, buffer_t *);

void destroy_channel (channel_t *);

#endif
